//
// Class CAbout1 for About Window 
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;

public class CAbout1 extends Dialog
{
  //Variables
  CGlobal g=null;
  static Image img_about=null;
  Dimension size;
  CAbout1c cv=null;

  // *******************************************************************
  public CAbout1(Frame dw, CGlobal glob)
  {
    super(dw, "About EOS Client ...", true);

    g=glob;

    String path="images"+g.cfg.GetParamStr(g.cfgSep)+"eos_c.gif";

    if (!CMisc.isFileExist(path))
    {
      System.out.println("Error: Can't find file /images/eos_c.gif!");
      System.exit(1);
    }

    long crc=CMisc.FileCRC(path);

    if (crc!=8763504)
    {
      System.out.println("File \"/images/eos_c.gif\" has been damaged!");
      System.exit(1);
    }

    img_about=Toolkit.getDefaultToolkit().getImage(path);

    if (img_about==null)
    {
      System.out.println("Error: Can't find file /images/eos_c.gif!");
      System.exit(1);
    }

    int wx=500;
    int wy=300;

    Dimension dim=Toolkit.getDefaultToolkit().getScreenSize();

    int mcx=dim.width;
    int mcy=dim.height;

    int cx=(mcx-wx)/2;
    int cy=(mcy-wy)/2;

    setLocation(cx, cy);

    add("Center", cv=new CAbout1c());
    cv.setSize(wx, wy);

    pack();

    size=getSize();

    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size) setSize(size);

    if (e.getID() == Event.WINDOW_DESTROY) dispose();
  }

  // *******************************************************************
  class CAbout1c extends Canvas
  {
    public void paint (Graphics g)
    {
      if (img_about != null) 
      {
        g.drawImage(img_about, 0, 0, this);
      }
    }			
  }
}
