//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import java.io.*;

public class CCalcNumIter extends Dialog implements ActionListener, Runnable
{
  //Variables
  Dimension size;

  Label comp1;
  Button comp2;

  String str2="Cancel";
  
  Frame Parent=null;

  Thread thrd=null;

  int Status;

  CGlobal g=null;

  int index=0;

  int ret=0;

  String str="";

  String ssn="";
  String pp="";
  String pt="";
  String pu="";
  String pg="";
  String pr="";
  boolean apo=true;

  // *******************************************************************
  public CCalcNumIter(Frame dw, CGlobal glob, int index1,
                      String ssnx, 
                      String ppx, String ptx, String pux,
                      String pgx, String prx,
                      boolean apox)
  {                                                                
    super(dw, "Calculate Number of Iterations ...", true);

    Status=-1;
    index=index1;

    Parent=dw;

    int gap=10;

    g=glob;

    ssn=ssnx;
    pp=ppx;
    pt=ptx;
    pu=pux;
    pg=pgx;
    pr=prx;
    apo=apox;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.CENTER);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);
    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    FlowLayout lt1=new FlowLayout(FlowLayout.CENTER);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    Panel p0=new Panel();
    p0.setLayout(lt0);
  
    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    comp1=new Label("______________________________________________________________________________", Label.CENTER);

    comp2=new Button(str2);
    comp2.addActionListener(this);

    p.add(p0);
	
    p0.add("North", p1);
    p0.add("South", p2);

    p1.add(comp1);

    p2.add(comp2);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    setResizable(false);

    //Packing elements in window
    pack();

//    comp1.setText("");

    size=getSize();
		
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
    AWTEvent.COMPONENT_EVENT_MASK);

    thrd=new Thread(this);
    thrd.start();		

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String command = e.getActionCommand();

    if (command.equals(str2))
    {	
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    }
  }

  // *******************************************************************
  public void run()
  { 
    comp1.setText("______________________________________________________________________________");
    try
    {
      thrd.sleep(50);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread!");
      System.exit(1);
    }

    comp1.setText("Initializing ...");

    int pt1=2;
    int pt2=50;
    int pt3=5;
    int pu1=1;
    int pu2=50;
    int pu3=5;
    int pp1=1;
    int pp2=50;
    int pp3=5;

    String x="";

    int ind1=pt.indexOf(",");
    int ind2=pt.indexOf(",", ind1+1);
  
    if ((ind1!=-1) && (ind2!=-1))
    {
      x=pt.substring(0,ind1).trim();

      try
      {
        pt1=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      x=pt.substring(ind1+1,ind2).trim();

      try
      {
        pt2=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      x=pt.substring(ind2+1,pt.length()).trim();

      try
      {
        pt3=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }

    ind1=pu.indexOf(",");
    ind2=pu.indexOf(",", ind1+1);
  
    if ((ind1!=-1) && (ind2!=-1))
    {
      x=pu.substring(0,ind1).trim();

      try
      {
        pu1=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      x=pu.substring(ind1+1,ind2).trim();

      try
      {
        pu2=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      x=pu.substring(ind2+1,pu.length()).trim();

      try
      {
        pu3=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }

    ind1=pp.indexOf(",");
    ind2=pp.indexOf(",", ind1+1);
  
    if ((ind1!=-1) && (ind2!=-1))
    {
      x=pp.substring(0,ind1).trim();

      try
      {
        pp1=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      x=pp.substring(ind1+1,ind2).trim();

      try
      {
        pp2=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      x=pp.substring(ind2+1,pp.length()).trim();

      try
      {
        pp3=Integer.valueOf(x).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }

    //Create CClient for Search Server
    CClient cl=new CClient();
    cl.RecordInstructions(g.cfg.GetParamStr(g.cfgRI));
    if (cl.Init(g.plt.GetConfig(index).GetParamStr(g.pltHost),
                g.cfg.GetParamInt(g.cfgSPort),
                32)!=0)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error (internal): Can't initialize object CClient!");
      mb=null;

      System.gc();
      System.runFinalization();

      Status=-3;
      dispose();
        
      return;
    }

    CFileManager fm=new CFileManager();
    fm.Init(g.cfg.GetParamStr(g.cfgSep), 
            g.cfg.GetParamStr(g.cfgPath),
            g.plt.GetConfig(index).GetParamStr(g.pltPath),
            g.prj_path1);

    //deleting diagnostic file
    str=g.cfg.GetParamStr(g.cfgPath);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.prj_path1;
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.cfg.GetParamStr(g.cfgPath1);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.f_diag22a;

    File fdel=null;
    try
    {
      fdel=new File(str);
      fdel.delete();
    }
    catch (NullPointerException e1)
    {}

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    //
    comp1.setText("Sending commands to server to calculate number of iterations ...");

    cl.Add("initiate search",                       true, true);
    cl.Add("directory="+g.prj_path1,                true, true);
    cl.Add("file_project="+g.prj_name,              true, true);
    cl.Add("file_diag_out="+g.f_diag22a+"."+ssn,    true, true);
    cl.Add("file_tree_in="+g.f_diag19a+"_",         true, true);
    cl.Add("file_time_out="+g.f_diag21a,            true, true);
    x="0";
    if (apo) x="1";
    cl.Add("array_pad_only="+x,                     true, true);
    cl.Add("strategy="+ssn,                         true, true);
    cl.Add("param_tile1="+String.valueOf(pt1),      true, true);
    cl.Add("param_tile2="+String.valueOf(pt2),      true, true);
    cl.Add("param_tile3="+String.valueOf(pt3),      true, true);
    cl.Add("param_unroll1="+String.valueOf(pu1),    true, true);
    cl.Add("param_unroll2="+String.valueOf(pu2),    true, true);
    cl.Add("param_unroll3="+String.valueOf(pu3),    true, true);
    cl.Add("param_pad1="+String.valueOf(pp1),       true, true);
    cl.Add("param_pad2="+String.valueOf(pp2),       true, true);
    cl.Add("param_pad3="+String.valueOf(pp3),       true, true);
    if (!pg.equals(""))
    {
      cl.Add("param_grid="+pg,                      true, true);
    }
    if (!pr.equals(""))
    {
      cl.Add("param_rnd="+pr,                       true, true);
    }
    cl.Add("go5",                                   true, true);
    cl.Add("terminate",                            false, true);

    
    ret=cl.Send();

    if (ret<0)
    {
      if (ret==-1)
      {
        str="Error: Can't find host with Search Server!";
      }
      else if (ret==-2)
      {
        str="Error: Can't connect to Search Server!";
      }
      else if (ret==-4)
      {
        str="Error: Can't close connection with Search Server!";
      }
      else if (ret<0)
      {
        str=cl.GetLastError();
      }

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, str);
      mb=null;

      System.gc();
      System.runFinalization();

      Status=-3;
      dispose();

      return;
    }

    //
    comp1.setText("Receiving diagnostic files from server ...");

    //it is important to have this delay here 
    //to allow server close dianostic file !!!
    try
    {
      thrd.sleep(1000);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    if (fm.receiveFile(g.f_diag22a+"."+ssn, g.cfg.GetParamStr(g.cfgPath1))!=0)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while receiving diag file!");
      mb=null;

      System.gc();
      System.runFinalization();

      Status=-2;
      dispose();
        
      return;
    }

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    Status=0;
    dispose();
  }

  // *******************************************************************
  public int getStatus()
  {
    return Status;
  }

  // *******************************************************************
  public void close_window()
  {
  }
}
