//
// Class CPlatOptWin for 'Platform Options Window'
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class CPlatOptWin extends Dialog implements ActionListener, ItemListener
{
  //Variables
  CGlobal g=null;

  int plt_num=0;

  Dimension size;

  String str1a="Add/Change";
  String str1b="Remove";
  String str1c="Ok";
  String str1d="Clear Fields";

  List lst=null;

  TextField  tf1=null;
  TextField  tf2=null;
  TextField  tf3=null;
  TextField  tf4=null;
  TextField  tf5=null;
  TextField  tf6=null;
  TextField  tf7=null;
  TextField  tf8=null;
  TextField  tf9=null;
  TextField tf10=null;
  TextField tf11=null;
  TextField tf12=null;

  // *******************************************************************
  public CPlatOptWin(Frame dw, CGlobal glob)
  {
    super(dw, "Platform Options", true);
 
    g=glob;

    int gap=5;

    //First panel for border
    BorderLayout lt1=new BorderLayout();
    lt1.setHgap(gap);
    lt1.setVgap(gap);

    Panel p1=new Panel();

    lst = new List(6, false);
    lst.addItemListener(this);

    //Adding names into list
    plt_num=g.plt.GetPlatformsNum();
    if (plt_num>0)
    {
      for (int i=0; i<plt_num; i++)
        lst.add(g.plt.GetConfig(i).GetParamStr(g.pltName));
    }

      FlowLayout lt1a=new FlowLayout();
      lt1a.setHgap(gap);
      lt1a.setVgap(gap);

      Panel p1a=new Panel();

      Button bt1=new Button(str1a);
      bt1.addActionListener(this);

      Button bt2=new Button(str1b);
      bt2.addActionListener(this);

      p1a.setLayout(lt1a);
      p1a.add(bt1);
      p1a.add(bt2);

    p1.setLayout(lt1);
    p1.add(lst, "North");
    p1.add(p1a, "South");

    BorderLayout lt2=new BorderLayout();
    lt2.setHgap(gap);
    lt2.setVgap(gap);

    Panel p2=new Panel();

      BorderLayout lt2aa=new BorderLayout();
      lt2aa.setHgap(gap);
      lt2aa.setVgap(gap);

      CFramedArea p2aa=new CFramedArea();

        GridLayout lt2ax=new GridLayout(12,1);
        lt2ax.setHgap(gap);
        lt2ax.setVgap(gap);

        Panel p2ax=new Panel();

        Label  cl1=new Label("Name:");
        Label  cl2=new Label("Processor:");
        Label  cl3=new Label("Frequency (MHz):");
        Label  cl4=new Label("Memory (mb):");
        Label  cl5=new Label("Cache L0 (kb):");
        Label  cl6=new Label("Cache L1 (kb):");
        Label  cl7=new Label("Cache L2 (kb):");
        Label  cl8=new Label("OS:");
        Label  cl9=new Label("Number of optimizations:");
        Label cl10=new Label("Time precision:");
        Label cl11=new Label("Host:");
        Label cl12=new Label("Path:");

        p2ax.setLayout(lt2ax);

        p2ax.add( cl1);
        p2ax.add( cl2);
        p2ax.add( cl3);
        p2ax.add( cl4);
//        p2ax.add( cl5);
        p2ax.add( cl6);
        p2ax.add( cl7);
        p2ax.add( cl8);
        p2ax.add( cl9);
        p2ax.add(cl10);
        p2ax.add(cl11);
        p2ax.add(cl12);
           
        GridLayout lt2ay=new GridLayout(12,1);
        lt2ay.setHgap(gap);
        lt2ay.setVgap(gap);

        Panel p2ay=new Panel();

         tf1=new TextField("", 40);
         tf2=new TextField("", 40);
         tf3=new TextField("", 40);
         tf4=new TextField("", 40);
         tf5=new TextField("", 40);
         tf6=new TextField("", 40);
         tf7=new TextField("", 40);
         tf8=new TextField("", 40);
         tf9=new TextField("", 40);
        tf10=new TextField("", 40);
        tf11=new TextField("", 40);
        tf12=new TextField("", 40);

        Button bt4=new Button(str1d);
        bt4.addActionListener(this);

        p2ay.setLayout(lt2ay);

        p2ay.add( tf1);
        p2ay.add( tf2);
        p2ay.add( tf3);
        p2ay.add( tf4);
//        p2ay.add( tf5);
        p2ay.add( tf6);
        p2ay.add( tf7);
        p2ay.add( tf8);
        p2ay.add( tf9);
        p2ay.add(tf10);
        p2ay.add(tf11);
        p2ay.add(tf12);
        p2ay.add(bt4);

      p2aa.setLayout(lt2aa);
      p2aa.add(p2ax,"West");
      p2aa.add(p2ay,"East");
            
      FlowLayout lt2a=new FlowLayout();
      lt2a.setHgap(gap);
      lt2a.setVgap(gap);

      Panel p2a=new Panel();

      Button bt3=new Button(str1c);
      bt3.addActionListener(this);

      p2a.setLayout(lt2a);
      p2a.add(bt3);

    p2.setLayout(lt2);
    p2.add(p2aa, "North");
    p2.add(p2a, "South");

    BorderLayout lt3=new BorderLayout();
    lt3.setHgap(gap);
    lt3.setVgap(gap);

    Panel p=new Panel();

    p.setLayout(lt3);
    p.add(p1, "North");
    p.add(p2, "South");

    FlowLayout lt=new FlowLayout(FlowLayout.LEFT);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);
    add(p);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    //Packing elements in window
    pack();

    size=getSize();
		
    //Initializing parameters
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String cm = e.getActionCommand();
    int i=0;

    if (cm.equals(str1a)) 
    {	        
      String name=tf1.getText();

      if (name.equals("")) return;

      for (i=0; i<plt_num; i++)
      {
        if (g.plt.GetConfig(i).GetParamStr(g.pltName).equals(name))
        {
          g.plt.Remove(i);
          lst.remove(i);

          break;
        }
      }

      lst.add(name, i);

      g.plt.Add(i);

      g.plt.GetConfig(i).SetParamStr(g.pltName,      tf1.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltProc,      tf2.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltFreq,      tf3.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltMemory,    tf4.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltCacheL0,   tf5.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltCacheL1,   tf6.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltCacheL2,   tf7.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltOS,        tf8.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltOpt,       tf9.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltTimePrec, tf10.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltHost,     tf11.getText());
      g.plt.GetConfig(i).SetParamStr(g.pltPath,     tf12.getText());

      if (i==plt_num) plt_num++;

      for (i=0; i<plt_num; i++) g.plt.GetConfig(i).Save();
    } 
    else if (cm.equals(str1b))
    {           
      i=lst.getSelectedIndex();

      if (i!=-1) 
      {
        g.plt.Remove(i);
        lst.remove(i);

        plt_num--;
      }

      for (i=0; i<plt_num; i++) g.plt.GetConfig(i).Save();
    } 
    else if (cm.equals(str1c)) 
    {
      dispose();
    } 
    else if (cm.equals(str1d)) 
    {
       tf1.setText("");
       tf2.setText("");
       tf3.setText("");
       tf4.setText("");
       tf5.setText("");
       tf6.setText("");
       tf7.setText("");
       tf8.setText("");
       tf9.setText("");
      tf10.setText("");
      tf11.setText("");
      tf12.setText("");
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      dispose();
    }
  }

  // *******************************************************************
  public void itemStateChanged(ItemEvent e1)
  {
    int i=lst.getSelectedIndex();

    if (i!=-1) 
    {
       tf1.setText(g.plt.GetConfig(i).GetParamStr(g.pltName));
       tf2.setText(g.plt.GetConfig(i).GetParamStr(g.pltProc));
       tf3.setText(g.plt.GetConfig(i).GetParamStr(g.pltFreq));
       tf4.setText(g.plt.GetConfig(i).GetParamStr(g.pltMemory));
       tf5.setText(g.plt.GetConfig(i).GetParamStr(g.pltCacheL0));
       tf6.setText(g.plt.GetConfig(i).GetParamStr(g.pltCacheL1));
       tf7.setText(g.plt.GetConfig(i).GetParamStr(g.pltCacheL2));
       tf8.setText(g.plt.GetConfig(i).GetParamStr(g.pltOS));
       tf9.setText(g.plt.GetConfig(i).GetParamStr(g.pltOpt));
      tf10.setText(g.plt.GetConfig(i).GetParamStr(g.pltTimePrec));
      tf11.setText(g.plt.GetConfig(i).GetParamStr(g.pltHost));
      tf12.setText(g.plt.GetConfig(i).GetParamStr(g.pltPath));
    }
  }
}
