//
// Class CViewFile
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class CViewFile extends Dialog implements ActionListener
{
  //Variables
  Dimension size;

  TextArea ta;

  Button comp2a;

  String str2a="OK";

  Frame Parent=null;
  
  // *******************************************************************
  public CViewFile(Frame dw, String filename_with_path)
  {
    super(dw, "File Viewer", true);

    Parent=dw;

    int gap=10;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.LEFT);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);

    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    FlowLayout lt1=new FlowLayout(FlowLayout.CENTER);
    lt1.setHgap(gap);
    lt1.setVgap(gap);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    //Creating components...
    ta=new TextArea("", 20, 80);
    ta.setEditable(false);
    p1.add(ta);

    comp2a=new Button(str2a);
    comp2a.addActionListener(this);

    p2.add(comp2a);

    p.setLayout(lt0);
    p.add("Center", p1);
    p.add("South", p2);		

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+80, pt.y+80);

    //loading file
    BufferedReader fin=null;

    try
    {
      fin=new BufferedReader(new FileReader(filename_with_path));
    }
    catch (IOException e2)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    int num_read=0;

    String str1="";
    try
    {
      while ((str1=fin.readLine())!=null)
      {
        ta.append(str1+"\n");
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
      }
      catch (Exception e3)
      {}

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while loading file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
    }

    //Packing elements in window
    pack();

    size=getSize();

    setResizable(false);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
    AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String command = e.getActionCommand();
    if (command.equals(str2a)) 
    {	        
      dispose();
    } 
  }

  //*******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      dispose();
    }
  }
}
