/*--------------------------------------------------------------------+
 | OCTAVE - Optimising Compiler Tool And Visualisation Environment    |
 |                                                                    |
 | Copyright (C) University of Edinburgh, 1993.                       |
 |                                                                    |
 | OCTAVE is free software; you can redistribute it and/or modify     |
 | it under the terms of the GNU General Public License as published  |
 | by the Free Software Foundation; either version 1, or (at your     |
 | option) any later version.                                         |
 |                                                                    |
 | OCTAVE is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of     |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
 | GNU General Public License for more details.                       |
 |                                                                    |
 | You should have received a copy of the GNU General Public License  |
 | along with OCTAVE; see the file COPYING.  If not, write to         |
 | the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,   |
 | USA.                                                               |
 +--------------------------------------------------------------------*/

#if ! defined _fortran_h_
#define _fortran_h_

// Scanner constants 

#define XEOF		0

// Character definitions

#define BLANKC		' '
#define MYQUOTE		(2)
#define MYHOLLERITH	(3)
#define BADHOLLERITH	(4)
#define NEWLINE		10

// input Fortran card types

#define STEOF		1
#define STINITIAL	2
#define STCONTINUE	3
#define CMT             4

// lexical scanner states

#define NEWSTMT		1
#define FIRSTTOKEN	2
#define OTHERTOKEN	3
#define RETEOS		4
#define COMMENTS	5
#define COMMENTSEOS     6
#define OVER            7

// Declared limits

#define MAX_NAME_LEN		29	// max length of Fortran name
#define MAXINCLUDES		8	// max number of include levels
#define MAXPARLEV		100	// max parenthesis nesting level
#define MAX_CONTIN_CARDS	99	// max number of continuation lines
#define NCHARS_PER_LINE		66	// max chars/line without longlines
#define BUFFERSIZE		1024	// number bytes read in one read
#define COMMENT_LENGTH          1000    // size of comment buffer
#define COMMENT_BUF_STORE	161     // size of individual comments


// Lexer-Parser interface parameters

#define STMT_BUFF_SIZE (NCHARS_PER_LINE * (MAX_CONTIN_CARDS + 1))
#define YY_TEXT_SIZE	1000

// The following 16 values are used to
// define symbolic attributes
// ( stored in symptr->attr ).

#define ALLOCATABLE_BIT		1
#define DIMENSION_BIT		2
#define EXTERNAL_BIT		8
#define IN_BIT			16
#define INOUT_BIT	        32
#define INTRINSIC_BIT	        64
#define OPTIONAL_BIT		128
#define OUT_BIT			256
#define PARAMETER_BIT		512
#define POINTER_BIT		1024
#define PRIVATE_BIT		2048
#define PUBLIC_BIT		4096
#define SAVE_BIT		8192
#define SEQUENCE_BIT		16384
#define RECURSIVE_BIT		32768
#define TARGET_BIT		65536


#endif // _fortran_h_
