#include "Octave/Base/ParseTree.h"
#include "Octave/Fortran/FortranParser.h"
#include "Octave/Base/Unparse.h"

void subroutineListing (PTR_STMT proc, dialect dlt)
{
  SourceListing list ;
  list.unparse (proc, ANSII_F77) ;
  SourceListingIterator next_line (list) ;
  SourceLine *line ;
  
  while (line = next_line() )
      printf ("%s", (*line)()) ;
}

void listing (FortranParser *fp)
{
  int numErrors = 0 ;
  slist_iterator<char*, string> next_error (fp->errors()) ;
  string *msg ;
  
  while (msg = next_error() )
  {
    ++numErrors ;
    fprintf (stderr, "%s", (*msg)()) ;
  }
  
  if (numErrors == 0) {
    // PTR_STMT root = fp->fileRoot() ;
    
    StmtListIterator next_routine (fp->fileRoot()->then_part()) ;
    PTR_STMT subprog ;

    while ((subprog = next_routine()))
      subroutineListing (subprog, ANSII_F77) ;
  }
}

void usage (char *option)
{
  fprintf (stderr, "test: illegal option '%s'\n", option) ;
  fprintf (stderr, "usage: test [-l] [-d] [-s] [-v] [-q] source.f\n") ;
  exit (EXIT_FAILURE) ;
}

int main (int argc, char *argv[])
{
  string *fname=new string ("/home/fgg/test/swim.f") ;

  FortranParser *ftn = new FortranParser (*fname) ;

  int parseErrors = ftn->parse () ;
  
  listing (ftn) ;

  delete ftn ;
}
