//
// Process Messages
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.net.*;
import java.io.*;

public class ProcessMessages
{
  public ProcessMessages(Socket sockfd, CGlobal g)
  {
    int misc;

    //Initialize instructions (need to do it in each process!)
    CSIParse sip = new CSIParse();

    if (sip.Init(30, 0)!=0)
    //            |  |
    //            |  |------- Case Sensitive (0) or not (1)
    //            |
    //            |---------- Max Number of Options
    {
      System.out.println("\nError: Can't initialize object CSIParse!");
      return;
    }

    misc=0;
  
    char ch=0;
    misc =sip.Add("initiate",               1, ' ', "");   //Param  0
    misc+=sip.Add("terminate",              0, ch,  "");   //Param  1
    misc+=sip.Add("directory",              1, '=', "");   //Param  2
    misc+=sip.Add("file_project",           1, '=', "");   //Param  3
    misc+=sip.Add("file_prof",              1, '=', "");   //Param  4
    misc+=sip.Add("file_tree",              1, '=', "");   //Param  5
    misc+=sip.Add("file_info",              1, '=', "");   //Param  6
    misc+=sip.Add("file_diag_out",          1, '=', "");   //Param  7
    misc+=sip.Add("optimization",           1, '=', "");   //Param  8
    misc+=sip.Add("dependency",             1, '=', "");   //Param  9
    misc+=sip.Add("loop_cache",             1, '=', "");   //Param 10
    misc+=sip.Add("stack_reg",              1, '=', "");   //Param 11
    misc+=sip.Add("lcomm_check",            1, '=', "");   //Param 12
    misc+=sip.Add("go1",                    0, ch,  "");   //Param 13
    misc+=sip.Add("go2",                    0, ch,  "");   //Param 14
    misc+=sip.Add("go3",                    0, ch,  "");   //Param 15
    misc+=sip.Add("go4",                    0, ch,  "");   //Param 16
    misc+=sip.Add("go5",                    0, ch,  "");   //Param 17
    misc+=sip.Add("go6",                    0, ch,  "");   //Param 18
    misc+=sip.Add("go7",                    0, ch,  "");   //Param 19
    misc+=sip.Add("go8",                    0, ch,  "");   //Param 20
    misc+=sip.Add("go9",                    0, ch,  "");   //Param 21
    misc+=sip.Add("go10",                   0, ch,  "");   //Param 22
    misc+=sip.Add("go11",                   0, ch,  "");   //Param 23
    misc+=sip.Add("go11x",                  0, ch,  "");   //Param 24
    misc+=sip.Add("param",                  1, '=', "");   //Param 25
    misc+=sip.Add("go12",                   0, ch,  "");   //Param 26
    misc+=sip.Add("param1",                 1, '=', "");   //Param 27
    misc+=sip.Add("file_diag_out_append",   1, '=', "");   //Param 28

    if (misc!=0)
    {
      System.out.println("\nError: Internal, while initializing CSIParse!");
      return;
    }

    //Process Instructions
    new ProcessInstructions(sockfd, g, sip);
  }      
}
