/*---------------------------------------------------------+
 |                                                         |
 | Root documentation file for the basic class library     |
 |                                                         |
 | This contains no active C++ source code, only           |
 | documentation code to be used in conjunction with       |
 | Cocoon.                                                 |
 |                                                         |
 +---------------------------------------------------------*/

/*--------------------------------------------------------------------+

LIBRARY 
  Obase

OVERVIEW
  This library libobase.a implements a basic set of utility classes
  for use in conjunction with libfe.a (the Fortran front-end class
  library).

CONTAINER CLASSES
 
  libobase.a implements a library of basic classes which use templates
  extensively. These include singly-linked lists, mappings (indexed
  by integer or character-string keys), universes, sets (which are
  bound to a particular universe) and co-universes.

  All parse-tree entities are contained within a Universe
  template class, and those Universes are themselves contained within the
  ParseContext class.
 
  The parser classes, FortranParser (and later the C++ parser), are
  derived from the ParseContext class. Each File object simply needs to
  to instantiate an xxxParser class to create the parse tree and symbol
  table structures for the file. The parser class also support a parser()
  member function which performs actual parsing.
 
--------------------------------------------------------------------*/
