import java.io.*;

public class eos_analysis_papi
{
  public static void main(String args[])
  {
    String fl1="eos_analysis_papi.papi_events";
    String fl2="eos_analysis_papi.papi_events_ratios";

    String fl3="_eos_llprof_out";

    if (args.length!=3)
    {
      System.out.println("");
      System.out.println("Error: command line should have three arguments!");
      System.exit(1);
    }

    //reading file with events
    BufferedReader fin=null;

    try 
    {
      fin=new BufferedReader(new FileReader(fl1));
    }
    catch (FileNotFoundException e1) 
    {
      System.out.println("Error while opening file with events");
      System.exit(1);
    }

    String[] events=new String[1024];
    String[] events1=new String[1024];

    String str="";
    int i=0;

    try  
    {
      while ((str=fin.readLine())!=null)  
      {
        if (!str.equals(""))
        {
          events[i]=str;
          i++;
        }
      }
    }
    catch (Exception e3)  
    {
      try  
      {
        fin.close();
      }
      catch (Exception e4)  {}
      System.out.println("Error while reading file with events");
      System.exit(1);
    }

    try  
    {
      fin.close();
    }
    catch (Exception e5)  
    {
      System.out.println("Error while closing file with events");
      System.exit(1);
    }

    int ievents=i;

    //reading file with events
    fin=null;

    try 
    {
      fin=new BufferedReader(new FileReader(fl2));
    }
    catch (FileNotFoundException e1) 
    {
      System.out.println("Error while opening file with ratios");
      System.exit(1);
    }

    String[] ratios=new String[1024];

    str="";
    i=0;

    try  
    {
      while ((str=fin.readLine())!=null)  
      {
        if (!str.equals(""))
        {
          ratios[i]=str;
          i++;
        }
      }
    }
    catch (Exception e3)  
    {
      try  
      {
        fin.close();
      }
      catch (Exception e4)  {}
      System.out.println("Error while reading file with ratios");
      System.exit(1);
    }

    try  
    {
      fin.close();
    }
    catch (Exception e5)  
    {
      System.out.println("Error while closing file with ratios");
      System.exit(1);
    }

    int iratios=i;

    //Start preparing output
    BufferedWriter fout=null;

    try 
    {
      fout=new BufferedWriter(new FileWriter(fl3+".PAPI__ALL."+
                                    args[0]+"."+args[1]+"."+args[2]));
    }
    catch (IOException e1) 
    {
      System.out.println("Error while opening file");
      System.exit(1);
    }

    boolean finish=false;
    int istep=0;
    try  
    {
      while (!finish)
      {
        for (int j=0; j<ievents; j++)
        {
          fin=null;

          try 
          {
            fin=new BufferedReader(new FileReader(fl3+"."+events[j]+"."+
                                      args[0]+"."+args[1]+"."+args[2]));
          }
          catch (FileNotFoundException e1) 
          {
            System.out.println("Error while opening file with events");
            System.exit(1);
          }
       
          str="";
          i=0;

          try  
          {
            while ((str=fin.readLine())!=null && (i<istep)) 
            {
              i++;
            }
            if (str!=null) events1[j]=str;
            else finish=true;
          }
          catch (Exception e3)  
          {
            try  
            {
              fin.close();
            }
            catch (Exception e4)  {}
            System.out.println("Error while reading file with events");
            System.exit(1);
          }

          try  
          {
            fin.close();
          }
          catch (Exception e5)  
          {
            System.out.println("Error while closing file with events");
            System.exit(1);
          }
        }

        if (!finish)
        {
          fout.write("******************************************************************************");
          fout.newLine();

          int i1=events1[0].indexOf("step={");
          int i2=events1[0].indexOf("},");

          if ((i1<0) || (i2<0))
          {
            fout.write("ERROR: can't find step info");
            fout.newLine();

            System.out.println("ERROR: can't find step info");
            System.exit(1);
          }

          String step=events1[0].substring(i1+6,i2).trim();
          
          int ii=i2+1;
          int jj=1;
          boolean found1=false;

          while (!found1)
          {
            i1=events1[0].indexOf("{", ii);
            i2=events1[0].indexOf("}/", ii);
            int i3=events1[0].indexOf("/{", ii);
            int i4=events1[0].indexOf("}", i3+1);

            if ((i1<0) || (i2<0) || (i3<0) || (i4<0))
            {
              found1=true;
            }
            else
            {
              fout.write("------------------------------------------------------------------------------");
              fout.newLine();
              fout.write("STEP:"+step);
              fout.newLine();
              fout.write("TIMER:"+String.valueOf(jj));
              fout.newLine();
              fout.newLine();

              ii=i4+1;
              jj++;

              //scan for empty events
              boolean found2=false;
              for (int j=0; j<ievents; j++)
              {

                if (!events1[j].substring(i3+2,i4).trim().equals("0"))
                {
                  found2=true;
                  break;
                }
              }

              if (!found2)
              {
                fout.write("no data");
                fout.newLine();
              }
              else
              {
                for (int j=0; j<ievents; j++)
                {
                  //align
                  str=events[j];
                  int k1=str.length();
                  for (int k=0; k<31-k1; k++) str+=" ";
                  fout.write(str+") "+events1[j].substring(i1,i4+1));
                  fout.newLine();
                }
                fout.newLine();

                //calculate ratios
                for (int j=0; j<iratios; j++)
                {
                  //align
                  str=ratios[j];

                  int q1=str.indexOf("=");
                  int q2=str.indexOf("/");

                  if ((q1>=0) && (q2>=0))
                  {
                    String str1=str.substring(0,q1).trim();
                    String str2=str.substring(q1+1,q2).trim();
                    String str3=str.substring(q2+1,str.length()).trim();

                    int qq2=-1;
                    for (int y=0; y<ievents; y++)
                    {
                      if (events[y].equals(str2))
                      {
                        qq2=y;
                        break;
                      }
                    }

                    int qq3=-1;
                    for (int y=0; y<ievents; y++)
                    {
                      if (events[y].equals(str3))
                      {
                        qq3=y;
                        break;
                      }
                    }

                    if ((qq2==-1) && (qq3==-1))
                    {
                      fout.write("ERROR: can't find step info");
                      fout.newLine();

                      System.out.println("ERROR: can't find step info");
                      System.exit(1);
                    }

                    double d2=0;
                    double d3=0;
                    try
                    {
                      d2=Double.valueOf(events1[qq2].substring(i3+2,i4).trim()).doubleValue();
                      d3=Double.valueOf(events1[qq3].substring(i3+2,i4).trim()).doubleValue();
                    }
                    catch (NumberFormatException nfe1)
                    {}

                    String res="";
                    if (d3!=0)
                    {
                      double d=d2/d3;
                      res=String.valueOf(d);
                    }
                    else res="?";
                    
                    int k1=str.length();
                    for (int k=0; k<31-k1; k++) str+=" ";
                    fout.write(str+") "+res);
                    fout.newLine();
                  }
                }
                fout.newLine();
              }
            }
          }

          istep++;
        }
      }
    }
    catch (Exception e3)  
    {
      try  
      {
        fout.close();
      }
      catch (Exception e4)  {}
      System.out.println("Error while writing file");
      System.exit(1);
    }

    try  
    {
      fout.close();
    }
    catch (Exception e5)  
    {
      System.out.println("Error while writing file");
      System.exit(1);
    }

    System.out.println("");
    System.out.println("End");

    System.exit(0);
  }

  //**************************************************************************
  public static String align_double(double param, int before, int after)
  {
    String str1=String.valueOf(param);
    String str2="";
    String str1a="";
    String str2a="";

    int i,i1;

    i1=str1.indexOf(".");
    if (i1!=-1)
    {
      str2=str1.substring(i1+1, str1.length());
      str1=str1.substring(0, i1);
    }

    str1a=align_str(str1, before);

    i1=str2.length();
    if (i1>after) str2a=str2.substring(0, after);
    else 
    {
      str2a=str2;
      for (i=i1; i<after; i++)
      {
        str2a+="0";
      }
    }

    return str1a+"."+str2a;
  }

  //**************************************************************************
  public static String align_str(String str, int len)
  {
    String str1=str;

    int i1=str.length();
    
    if (i1<len)
    {
      for (int i=i1; i<len; i++)
      {
        str1=" "+str1;
      }
    }
    
    return str1;
  }
}
