import java.io.*;

public class eos_analysis_papi_compare
{
  public static void main(String args[])
  {
    String fl3="_eos_llprof_out";
    String fl4="PAPI__ALL";

    if (args.length!=4)
    {
      System.out.println("");
      System.out.println("Error: command line should have four arguments!");
      System.exit(1);
    }

    int i=0;
    int imax=0;
    try
    {
      imax=Integer.valueOf(args[3]).intValue();
    }
    catch (NumberFormatException nfe1)
    {}

    if (imax<2)
    {
      System.out.println("");
      System.out.println("Error: number of files to compare should be > 1 !");
      System.exit(1);
    }

    BufferedWriter fout=null;

    try 
    {
      fout=new BufferedWriter(new FileWriter(fl3+".PAPI__ALL_COMPARE."+
                                    args[0]+"."+args[1]));
    }
    catch (IOException e1) 
    {
      System.out.println("Error while opening file to write");
      System.exit(1);
    }

    BufferedReader[] fin=new BufferedReader[imax+1];

    for (i=1; i<=imax; i++)
    {
      try 
      {
        fin[i]=new BufferedReader(new FileReader(fl3+"."+fl4+"."+args[0]+"."+args[1]+
                    "."+args[2]+String.valueOf(i)));
      }
      catch (FileNotFoundException e1) 
      {
        System.out.println("Error while opening file to read");
        System.exit(1);
      }
    }

    String[] str=new String[imax+1];
    for (i=1; i<=imax; i++) str[i]="";

    while ((str[1]=ReadFromFile(fin[1]))!=null)
    {
      for (i=2; i<=imax; i++)
      {
        str[i]=ReadFromFile(fin[i]);
      }

      int j=str[1].indexOf(")");
      if (j<0)
      {
        if ((WriteToFile(fout, str[1])<0) || (WriteToFileNewLine(fout)<0))
        {
          System.out.println("Error while writing file");
          System.exit(1);
        }
      }
      else
      {
        String strx=str[1].substring(0,j+1);
        for (i=1; i<=imax; i++)
        {
          String stry=str[i].substring(j+1, str[i].length()).trim();
          int k1=stry.length();
          for (int k=0; k<25-k1; k++) stry=" "+stry;
          strx+=" "+stry;
        }

        if ((WriteToFile(fout, strx)<0) || (WriteToFileNewLine(fout)<0))
        {
          System.out.println("Error while writing file");
          System.exit(1);
        }
      }
    }

    for (i=1; i<=imax; i++)
    {
      try 
      {
        fin[i].close();
      }
      catch (Exception e1) 
      {
      }
    }

    try  
    {
      fout.close();
    }
    catch (Exception e5)  
    {
      System.out.println("Error while writing file");
      System.exit(1);
    }

    System.out.println("");
    System.out.println("End");

    System.exit(0);
  }

  //*************************************************************************
  private static String ReadFromFile(BufferedReader fin)
  {
    String str=null;
    try  
    {
      str=fin.readLine();
    }
    catch (Exception e)  
    {
    }
    return str;
  }

  //*************************************************************************
  private static int WriteToFile(BufferedWriter fout, String str)
  {
    int i=0;
    try  
    {
      fout.write(str);
    }
    catch (Exception e)  
    {
      i=-1;
    }
    return i;
  }

  //*************************************************************************
  private static int WriteToFileNewLine(BufferedWriter fout)
  {
    int i=0;
    try  
    {
      fout.newLine();
    }
    catch (Exception e)  
    {
      i=-1;
    }
    return i;
  }
}
