//
// eos_convert1 - convert files of type "eos_ss.lri_nabokov_unix._eos_prj.1c_1_3"
//                into "convert1a.txt" & "convert1b.txt" files with times only
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

//Main class
public class eos_convert1
{
  //**************************************************************************
  public static void main(String args[])
  {
    String tmp="convert1a.txt";
    String tmp1="convert1b.txt";
    String str="";

    //Logo
    System.out.println("Convert1   (C) by Grigori G.Fursin   December,2002");

    if (args.length!=1)
    {
      System.out.println("                                 ");
      System.out.println("Usage:                           ");
      System.out.println(" java convert1 <filename>        ");
      System.out.println("                                 ");
      System.out.println("More information:                ");
      System.out.println(" http://www.dcs.ed.ac.uk/home/fgg");
      System.exit(0);
    }

    //Filename
    String fn=args[0];

    BufferedReader fin=null;
    BufferedWriter fout=null;
    BufferedWriter fout1=null;

    try
    {
      fin=new BufferedReader(new FileReader(fn));
      fout=new BufferedWriter(new FileWriter(tmp));
      fout1=new BufferedWriter(new FileWriter(tmp1));
    }
    catch (IOException e2)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't open file(s)!");
      System.exit(1);
    }

    try
    {
      int j=1;

      while ((str=fin.readLine())!=null)
      {
        str=str.toLowerCase();
        if (str.indexOf("(transformed)")!=-1)
        {
          int i1=str.indexOf("=");
          int i2=str.indexOf("]",i1+1);
          String str1=str.substring(i1+1,i2).trim();
  
          fout.write(str1); 
          fout.newLine();

          fout1.write(String.valueOf(j)+", "+str1); 
          fout1.newLine();

          j++;
        }
        else if (str.indexOf("incorrect")!=-1)
        {
          fout.write(""); 
          fout.newLine();

          fout1.write(String.valueOf(j)+","); 
          fout1.newLine();

          j++;
        }
        else if (str.indexOf("not created")!=-1)
        {
          fout.write(""); 
          fout.newLine();

          fout1.write(String.valueOf(j)+","); 
          fout1.newLine();

          j++;
        }
      }
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
        fout.close();
        fout1.close();
      }
      catch (Exception e4)
      {}
      System.out.println("");
      System.out.println("Fatal Error: Problems with file(s)!");
      System.exit(1);
    }

    try
    {
      fin.close();
      fout.close();
      fout1.close();
    }
    catch (Exception e5)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't close file(s)!");
      System.exit(1);
    }

    System.out.println("");
    System.out.println("Program finished sucessfully!");

    System.exit(0);
  }
}
