//
// eos_convert2 - convert file with vertial vector into horizontal one
//                and save into convert2.xls (with tabs)
//             
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

//Main class
public class eos_convert2
{
  //**************************************************************************
  public static void main(String args[])
  {
    String tmp="convert2.xls";
    String str="";

    //Logo
    System.out.println("Convert2   (C) by Grigori G.Fursin   December,2002");

    if (args.length!=1)
    {
      System.out.println("                                 ");
      System.out.println("Usage:                           ");
      System.out.println(" java convert2 <filename>        ");
      System.out.println("                                 ");
      System.out.println("More information:                ");
      System.out.println(" http://www.dcs.ed.ac.uk/home/fgg");
      System.exit(0);
    }

    //Filename
    String fn=args[0];

    BufferedReader fin=null;
    BufferedWriter fout=null;

    try
    {
      fin=new BufferedReader(new FileReader(fn));
      fout=new BufferedWriter(new FileWriter(tmp));
    }
    catch (IOException e2)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't open file(s)!");
      System.exit(1);
    }

    try
    {
      while ((str=fin.readLine())!=null)
      {
        fout.write(str+"\t");
      }
      fout.newLine();
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e4)
      {}
      System.out.println("");
      System.out.println("Fatal Error: Problems with file(s)!");
      System.exit(1);
    }

    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e5)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't close file(s)!");
      System.exit(1);
    }

    System.out.println("");
    System.out.println("Program finished sucessfully!");

    System.exit(0);
  }
}
